    @name = 'huge-play:middleware:queuer'
    debug = (require 'debug') @name
    seem = require 'seem'

    queuer = require 'black-metal/queuer'

    API = require 'black-metal/api'
    {TaggedCall,TaggedAgent} = require 'black-metal/tagged'

    @server_pre = ->

      redis = @cfg.redis_client
      prov = @cfg.prov
      profile = @cfg.session?.profile
      api = API @cfg

      return unless redis? and prov? and profile?

      class HugePlayCall extends TaggedCall

        redis: redis
        api: api
        profile: profile

      class HugePlayAgent extends TaggedAgent

        redis: redis

        new_call: (data) -> new HugePlayCall data

        create_egress_call: seem ->

          call = null

          @number_domain_data ?= yield prov
            .get "number_domain:#{@domain}"
            .catch (error) -> null

          if @number_domain_data?.queuer_webhook?
            {body} = yield request
              .post @number_domain_data.queuer_webhook
              .send {@key,@number,@domain,tags:@tags()}

            body.tags ?= []
            if body.destination? and body.tags? and body.tags.length?
              body.tags.push 'egress'
              call = new HugePlayCall
                destination: body.destination
                tags: body.tags

          return call

      Queuer = queuer
        redis: @cfg.redis_client
        Agent: HugePlayAgent
        Call: HugePlayCall
      @cfg.queuer_Agent = HugePlayAgent
      @cfg.queuer_Call = HugePlayCall
      @cfg.queuer = new Queuer @cfg

    @include = ->

      queuer = @cfg.queuer
      Agent = @cfg.queuer_Agent

      return unless queuer? and Agent?

      start_of_call = seem ({key,id}) ->
        debug 'Start of call', key, id
        agent = new Agent queuer, key
        yield agent.add_call id

      end_of_call = seem ({key,id}) ->
        debug 'End of call', key, id
        agent = new Agent queuer, key
        yield agent.del_call id

      @call.once 'inbound', start_of_call
      @call.once 'outbound', start_of_call
      @call.once 'inbound-end', end_of_call
      @call.once 'outbound-end', end_of_call

On-hook agent: add queue, remove queue

      @fifo_add = seem (source,fifo) ->
        debug 'fifo_add', source
        agent = new Agent queuer, source
        yield agent.add_tag "queue:#{fifo.full_name}" if fifo?.full_name?
        yield agent.accept_onhook()
        agent

      @fifo_del = seem (source,fifo) ->
        debug 'fifo_del', source
        agent = new Agent queuer, source
        yield agent.del_tag "queue:#{fifo.full_name}" if fifo?.full_name?
        yield agent.transition 'logout'
        agent

Off-hook agent

      @fifo_offhook = seem (source,{uuid},fifo) ->
        debug 'fifo_offhook', source, uuid, fifo
        agent = new Agent queuer, source
        yield agent.add_tag "queue:#{fifo.full_name}" if fifo?.full_name?
        yield agent.accept_offhook uuid
        agent
